import java.util.*;
import java.math.*;
import java.util.Random;
import java.io.*;

public class K_N {
/**
 *  The Algorithm of  "( 2, n ) Secret Sharing "
 */

	int p,M,n,a;
	int[] k ;

	public K_N(int org, int div){

		M = org;
		n = div;
		a = 0;
		p = 0;
	    k = new int[n+1];

	}




/*	public static void main(String[] args) throws IOException
	{
		InputStreamReader is = new InputStreamReader(System.in);


		int a = ran(M);


		k = enc(n,a,M,k);

		System.out.println(n + "以下の２つの数を入力してください");

		int a1 = 3;
		int a2 = 2;

		int res = dec(n,k,a1,a2);

	}*/

	public int ran()
	{
		Random rnd = new Random();
		a = rnd.nextInt(20) + 1;

		 p = (a > M ? a : M) + 1;

		boolean f = false;
		while(!f){
			f = true;
			p += rnd.nextInt(10);
			for(int i = 2 ; i*i < p ; i++){
				if(p % i == 0){
					f = false;
					break;
				}
			}
		}

		System.out.println("F(x) = " + a + "x + " + M + " mod " + p);

		return a;

	}

	public void enc()
	{
		for(int i = 1;i < n + 1;i++){
			k[i] = (a * i + M);
			// % p;
			System.out.println("key" + i + ": " + k[i]);
		}
	}

	public int dec(int a1, int a2)
	{
		if((a1 > a2 ? a1 : a2) > n){
			return -1; //もし分散数nより大きな値だったら、-1を返して終了
		}

		int res = ( (k[a2]*a1 - k[a1]*a2) / (a1 - a2) );
		System.out.println("answer: " + res);

		return res;

	}



}


